#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include "MSX.h"

char *Options[]=
{ 
  "verbose","ifreq","iperiod","uperiod","help","printer",
  "shm","noshm","ram","vram","trap","msx1","msx2","msx2+",
  "rom","diska","diskb","font",NULL
};

extern char *Title;
extern int   UseSHM;
extern int   IFreq;

main(argc,argv)
  int argc;
  char *argv[];
{
  int N,J,I;

  IFreq=50;IPeriod=6000;UPeriod=2;
  RAMPages=4;VRAMPages=2;MSXVersion=0;
  IntSync=1;Verbose=1;ROMType=0;

  for(N=1,I=0;N<argc;N++)
    if(*argv[N]!='-')
      switch(I++)
      {
        case 0: CartA=argv[N];break;
        case 1: CartB=argv[N];break;
        default: printf("%s: Excessive filename '%s'\n",argv[0],argv[N]);
      }
    else
    {    
      for(J=0;Options[J];J++)
        if(!strcmp(argv[N]+1,Options[J])) break;
      switch(J)
      {
        case 0:  N++;
                 if(N<argc) Verbose=atoi(argv[N]);
                 else printf("%s: No verbose level supplied\n",argv[0]);
                 break;
        case 1:  N++;
                 if(N>=argc)
                   printf("%s: No interrupt frequency supplied\n",argv[0]);
                 else
                 {
                   IntSync=0;IFreq=atoi(argv[N]);
                   if((IFreq<2)||(IFreq>200)) IFreq=50;
                 }
                 break;
  	case 2:  N++;
                 if(N>=argc)
                   printf("%s: No interrupt period supplied\n",argv[0]);
                 else
                 {
                   IntSync=1;IPeriod=atoi(argv[N]);
                   if((IPeriod<100)||(IPeriod>50000)) IPeriod=6000;
                 }
                 break;
  	case 3:  N++;
                 if(N>=argc)
                   printf("%s: No screen update period supplied\n",argv[0]);
                 else
                 {
                   UPeriod=atoi(argv[N]);
                   if((UPeriod<1)||(UPeriod>20)) UPeriod=2;
                 }
                 break;
	case 4:  printf("%s by Marat Fayzullin    (C)FMS 1994,1995\n",Title);
                 puts("Usage: fmsx [-option1 [-option2...]] [filename1] [filename2]]");
                 puts("[filename1] = name of file to load as cartridge A");
                 puts("[filename2] = name of file to load as cartridge B");
                 puts("[-option]   = -verbose <level>");
                 puts("              -ifreq <frequency>");
                 puts("              -iperiod <period>");
                 puts("              -uperiod <period>");
                 puts("              -help");
                 puts("              -printer <filename>");
#ifdef MITSHM
                 puts("              -shm/-noshm");
#endif
                 puts("              -ram <pages>");
                 puts("              -vram <pages>");
#ifdef DEBUG
                 puts("              -trap <address>");
#endif
                 puts("              -msx1/-msx2/-msx2+");
                 puts("              -rom <type>");
                 puts("              -diska <filename>");
                 puts("              -diskb <filename>");
                 puts("              -font <filename>");
                 return(0);
        case 5:  N++;
                 if(N<argc) PrnName=argv[N];
                 else printf("%s: No file for printer redirection\n",argv[0]);
                 break;
#ifdef MITSHM
        case 6:  UseSHM=1;break;
        case 7:  UseSHM=0;break;
#endif
        case 8:  N++;
                 if(N>=argc)
                   printf("%s: No number of RAM pages supplied\n",argv[0]);
                 else
                   RAMPages=atoi(argv[N]);
                 break;
        case 9:  N++;
                 if(N>=argc)
                   printf("%s: No number of VRAM pages supplied\n",argv[0]);
                 else
                   VRAMPages=atoi(argv[N]);
                 break;
#ifdef DEBUG
        case 10: N++;
                 sscanf(argv[N],"%X",&Trap);
                 break;
#endif
        case 11: MSXVersion=0;break;
        case 12: MSXVersion=1;break;
        case 13: MSXVersion=2;break;
        case 14: N++;  
                 if(N>=argc)
                   printf("%s: No ROM mapper type supplied\n",argv[0]);
                 else
                   ROMType=atoi(argv[N]);
                 break;
        case 15: N++;
                 if(N<argc) DiskA=argv[N];
                 else printf("%s: No file for drive A\n",argv[0]);
                 break;
        case 16: N++;
                 if(N<argc) DiskB=argv[N];
                 else printf("%s: No file for drive B\n",argv[0]);
                 break;
        case 17: N++;
                 if(N<argc) FontName=argv[N];  
                 else printf("%s: No font name supplied\n",argv[0]);
                 break;
        default: printf("%s: Wrong option '%s'\n",argv[0],argv[N]);
      }
    }

  if(!InitMachine()) return(1);
  StartMSX();TrashMSX();
  TrashMachine();
  return(0);
}











