*
* Misc.s
* several x68k-dependent codes
* Copyright (C) 1995 Yasushi Yamasaki
*

WIDTH	.equ	320
WIDTH2	.equ	640
HEIGHT	.equ	240

MFP_IMRA	.equ	$00e88013
MFP_IMRB	.equ	$00e88015


	.globl _XBuf


	.text
	.even

*
* put screen image to frame buffer ( 256 width )
*
	.globl _PutImage256
_PutImage256:
	move.l	_XBuf,a0
	lea.l	$c00000+(384-WIDTH)+(256-HEIGHT)/2*1024,a1

	move.w	#HEIGHT-1,d1
1:
	move.w	#WIDTH/64-1,d0
@@:
	.rept	32
	move.w	(a0)+,(a1)
	addq.l	#4,a1
	.endm
	dbf	d0,@b
	add.w	#(512-WIDTH)*2,a1
	dbf	d1,1b

	rts


*
* put screen image to frame buffer ( 512 width )
*
	.globl _PutImage512
_PutImage512:
	move.l	_XBuf,a0
	lea.l	$c00000+(768-WIDTH2)+(256-HEIGHT)/2*2048+1,a1

	move.w	#HEIGHT-1,d1
1:
	move.w	#WIDTH2/32-1,d0
@@:
	.rept	32
	move.b	(a0)+,(a1)+
	addq.l	#1,a1
	.endm
	dbf	d0,@b
	add.w	#(1024-WIDTH2)*2,a1
	dbf	d1,1b

	rts


*
* key input interrupt handler
*
	.globl  _KeyIntrSub
	.globl	_KeyIntrHandler
_KeyIntrHandler:
	and.b	#$ef,MFP_IMRA			* disable interrupt
	movem.l	d0-d7/a0-a6,-(sp)
	jsr	_KeyIntrSub			* call C subroutine
	movem.l	(sp)+,d0-d7/a0-a6
	or.w	#$0700,sr
	or.b	#$10,MFP_IMRA			* enable interrupt
	rte


*
* timer interrupt handler
*
	.globl	_TimerIntrSub
	.globl	_TimerIntrHandler
_TimerIntrHandler:
	and.b	#$bf,MFP_IMRB			* disable interrupt
	movem.l	d0-d7/a0-a6,-(sp)
	jsr	_TimerIntrSub			* call C subroutine
	movem.l	(sp)+,d0-d7/a0-a6
	or.w	#$0700,sr
	or.b	#$40,MFP_IMRB			* enable interrupt
	rte


	.end

