/*
 * x68k.h
 * X68k-dependent I/O port structure, etc.
 * Copyright (C) Yasushi Yamasaki 1995
 */

/* registers of CRT Controller(CRTC) */
volatile struct Crtc {
	unsigned short r00,r01,r02,r03,r04,r05,r06,r07;
	unsigned short r08,r09,r10,r11,r12,r13,r14,r15;
	unsigned short r16,r17,r18,r19,r20,r21,r22,r23;
} *crtc = (struct Crtc *)0xe80000;

/* registers of Video Controller */
volatile unsigned short *videoR0 = (unsigned short *)0xe82400;
volatile unsigned short *videoR1 = (unsigned short *)0xe82500;
volatile unsigned short *videoR2 = (unsigned short *)0xe82600;

/* System Port */
volatile struct Sysport {
	unsigned short r1,r2,r3,r4,r5,r6;
} *sysport = (struct Sysport *)0xe8e000;

/* Graphic Palette */
volatile unsigned short *gpalet = (unsigned short *)0xe82000;

/* Graphic Frame Buffer */
volatile unsigned short *gframe = (unsigned short *)0xc00000;

/* MFP USART data register ( for keyboard input ) */
volatile unsigned char *usart = (unsigned char *)0xe8802f;

/* EOF of x68k.h */
